<?php

function microtime_float()
{
   list($usec, $sec) = explode(' ', microtime());
   return ((float)$usec + (float)$sec);
}

function lockFile($filename, $timeLimit = 300000, $staleAge = 5) {
   ignore_user_abort(1);
   $lockDir = $filename . '.lock';

   if (is_dir($lockDir)) {
       if ((time() - filemtime($lockDir)) > $staleAge) {
           rmdir($lockDir);
       }
   }

   $locked = @mkdir($lockDir);

   if ($locked === false) {
       $timeStart = microtime_float();
       do {
           if ((microtime_float() - $timeStart) > $timeLimit) break;
           $locked = @mkdir($lockDir);
       } while ($locked === false);
   }

   return $locked;
}


function unlockFile($filename) {

  $lockDir = $filename . '.lock';
  rmdir($lockDir);

  ignore_user_abort(0);
}

function glue_url($parsed) {
  if (! is_array($parsed)) return false;
  $uri = $parsed['scheme'] ? $parsed['scheme'].':'.((strtolower($parsed['scheme']) == 'mailto') ? '':'//'): '';
  $uri .= $parsed['user'] ? $parsed['user'].($parsed['pass']? ':'.$parsed['pass']:'').'@':'';
  $uri .= $parsed['host'] ? $parsed['host'] : '';
  $uri .= $parsed['port'] ? ':'.$parsed['port'] : '';
  $uri .= $parsed['path'] ? $parsed['path'] : '';
  $uri .= $parsed['query'] ? '?'.$parsed['query'] : '';
  $uri .= $parsed['fragment'] ? '#'.$parsed['fragment'] : '';
  return $uri;
} 

?>